window.Gleam.initSearch([{"doc":"ngs","title":"ngs","content":"# ngs\n\nWrite functional type-safe nginx script (njs) with [gleam](https://gleam.run)\nThe app built conforms `es2020` standard, therefore it requires NJS QuickJS engine.\n\n[![Package Version](https://img.shields.io/hexpm/v/ngs)](https://hex.pm/packages/ngs)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/ngs/)\n\nFurther documentation can be found at &lt;https://hexdocs.pm/ngs&gt;.\n\n## Development\n\n","url":"index.html"},{"doc":"njs/buffer","title":"ArrayBuffer","content":"pub type ArrayBuffer\n\n\nSynonyms:\nnjs/buffer.ArrayBuffer\nnjs/buffer ArrayBuffer","url":"njs/buffer.html#ArrayBuffer"},{"doc":"njs/buffer","title":"Buffer","content":"pub type Buffer\n\n\nSynonyms:\nnjs/buffer.Buffer\nnjs/buffer Buffer","url":"njs/buffer.html#Buffer"},{"doc":"njs/buffer","title":"Byte","content":"pub type Byte =\n  BitArray\n Byte is size(8) unit(1) bitarray\n\nSynonyms:\nnjs/buffer.Byte\nnjs/buffer Byte","url":"njs/buffer.html#Byte"},{"doc":"njs/buffer","title":"Encoding","content":"pub type Encoding {\n  Utf8\n  Hex\n  Base64\n  Base64Url\n}\n\nUtf8\n\n\nHex\n\n\nBase64\n\n\nBase64Url\n\n\nSynonyms:\nnjs/buffer.Encoding\nnjs/buffer Encoding","url":"njs/buffer.html#Encoding"},{"doc":"njs/buffer","title":"TypedArray","content":"pub type TypedArray\n\n\nSynonyms:\nnjs/buffer.TypedArray\nnjs/buffer TypedArray","url":"njs/buffer.html#TypedArray"},{"doc":"njs/buffer","title":"TypedArrayType","content":"pub type TypedArrayType {\n  Int8\n  UInt8\n  Int16\n  UInt16\n  Int32\n  UInt32\n}\n\nInt8\n\n\nUInt8\n\n\nInt16\n\n\nUInt16\n\n\nInt32\n\n\nUInt32\n\n\nSynonyms:\nnjs/buffer.TypedArrayType\nnjs/buffer TypedArrayType","url":"njs/buffer.html#TypedArrayType"},{"doc":"njs/buffer","title":"alloc","content":"pub fn alloc(size s: Int) -&gt; Buffer\n\nSynonyms:\nnjs/buffer.alloc\nnjs/buffer alloc","url":"njs/buffer.html#alloc"},{"doc":"njs/buffer","title":"byte_length","content":"pub fn byte_length(value v: a, encoding e: Encoding) -&gt; Int\n\nSynonyms:\nnjs/buffer.byte_length\nnjs/buffer byte_length","url":"njs/buffer.html#byte_length"},{"doc":"njs/buffer","title":"compare","content":"pub fn compare(buffer1 b1: Buffer, buffer2 b2: Buffer) -&gt; Int\n\nSynonyms:\nnjs/buffer.compare\nnjs/buffer compare","url":"njs/buffer.html#compare"},{"doc":"njs/buffer","title":"concat","content":"pub fn concat(buffers bs: Array(Buffer), length t: a) -&gt; Buffer\n\nSynonyms:\nnjs/buffer.concat\nnjs/buffer concat","url":"njs/buffer.html#concat"},{"doc":"njs/buffer","title":"copy","content":"pub fn copy(\n  dst bd: Buffer,\n  src bs: Buffer,\n  from f: Int,\n  to t: Int,\n) -&gt; Buffer\n\nSynonyms:\nnjs/buffer.copy\nnjs/buffer copy","url":"njs/buffer.html#copy"},{"doc":"njs/buffer","title":"equals","content":"pub fn equals(buffer1 b1: Buffer, buffer2 b2: Buffer) -&gt; Bool\n\nSynonyms:\nnjs/buffer.equals\nnjs/buffer equals","url":"njs/buffer.html#equals"},{"doc":"njs/buffer","title":"fill","content":"pub fn fill(\n  buffer bf: Buffer,\n  with v: BitArray,\n  from f: Int,\n  to t: Int,\n) -&gt; Buffer\n\nSynonyms:\nnjs/buffer.fill\nnjs/buffer fill","url":"njs/buffer.html#fill"},{"doc":"njs/buffer","title":"from","content":"pub fn from(\n  array_buffer ab: ArrayBuffer,\n  offset o: Int,\n  length l: Int,\n) -&gt; Buffer\n\nSynonyms:\nnjs/buffer.from\nnjs/buffer from","url":"njs/buffer.html#from"},{"doc":"njs/buffer","title":"from_buffer","content":"pub fn from_buffer(buffer bf: Buffer) -&gt; Buffer\n\nSynonyms:\nnjs/buffer.from_buffer\nnjs/buffer from_buffer","url":"njs/buffer.html#from_buffer"},{"doc":"njs/buffer","title":"from_bytes","content":"pub fn from_bytes(array ab: Array(BitArray)) -&gt; Buffer\n\nSynonyms:\nnjs/buffer.from_bytes\nnjs/buffer from_bytes","url":"njs/buffer.html#from_bytes"},{"doc":"njs/buffer","title":"from_string","content":"pub fn from_string(\n  bitarray ba: BitArray,\n  encoding e: Encoding,\n) -&gt; Buffer\n\nSynonyms:\nnjs/buffer.from_string\nnjs/buffer from_string","url":"njs/buffer.html#from_string"},{"doc":"njs/buffer","title":"get_buffer","content":"pub fn get_buffer(buffer bf: Buffer) -&gt; ArrayBuffer\n\nSynonyms:\nnjs/buffer.get_buffer\nnjs/buffer get_buffer","url":"njs/buffer.html#get_buffer"},{"doc":"njs/buffer","title":"get_buffer_offset","content":"pub fn get_buffer_offset(buffer b: Buffer) -&gt; Int\n\nSynonyms:\nnjs/buffer.get_buffer_offset\nnjs/buffer get_buffer_offset","url":"njs/buffer.html#get_buffer_offset"},{"doc":"njs/buffer","title":"get_byte","content":"pub fn get_byte(buffer bf: Buffer, offset o: Int) -&gt; BitArray\n\nSynonyms:\nnjs/buffer.get_byte\nnjs/buffer get_byte","url":"njs/buffer.html#get_byte"},{"doc":"njs/buffer","title":"includes","content":"pub fn includes(\n  buffer bf: Buffer,\n  value v: a,\n  offset o: Int,\n) -&gt; Bool\n\nSynonyms:\nnjs/buffer.includes\nnjs/buffer includes","url":"njs/buffer.html#includes"},{"doc":"njs/buffer","title":"includes_string","content":"pub fn includes_string(\n  buffer bf: Buffer,\n  value v: BitArray,\n  offset o: Int,\n  encoding e: Encoding,\n) -&gt; Bool\n\nSynonyms:\nnjs/buffer.includes_string\nnjs/buffer includes_string","url":"njs/buffer.html#includes_string"},{"doc":"njs/buffer","title":"index_of","content":"pub fn index_of(\n  buffer bf: Buffer,\n  value v: a,\n  offset o: Int,\n) -&gt; Int\n\nSynonyms:\nnjs/buffer.index_of\nnjs/buffer index_of","url":"njs/buffer.html#index_of"},{"doc":"njs/buffer","title":"index_of_string","content":"pub fn index_of_string(\n  buffer bf: Buffer,\n  value v: BitArray,\n  offset o: Int,\n  encoding e: Encoding,\n) -&gt; Int\n\nSynonyms:\nnjs/buffer.index_of_string\nnjs/buffer index_of_string","url":"njs/buffer.html#index_of_string"},{"doc":"njs/buffer","title":"last_index_of","content":"pub fn last_index_of(\n  buffer bf: Buffer,\n  value v: a,\n  offset o: Int,\n  encoding e: Encoding,\n) -&gt; Int\n\nSynonyms:\nnjs/buffer.last_index_of\nnjs/buffer last_index_of","url":"njs/buffer.html#last_index_of"},{"doc":"njs/buffer","title":"last_index_of_string","content":"pub fn last_index_of_string(\n  buffer bf: Buffer,\n  value v: BitArray,\n  offset o: Int,\n  encoding e: Encoding,\n) -&gt; Int\n\nSynonyms:\nnjs/buffer.last_index_of_string\nnjs/buffer last_index_of_string","url":"njs/buffer.html#last_index_of_string"},{"doc":"njs/buffer","title":"length","content":"pub fn length(buffer bf: Buffer) -&gt; Int\n\nSynonyms:\nnjs/buffer.length\nnjs/buffer length","url":"njs/buffer.html#length"},{"doc":"njs/buffer","title":"new_array_buffer","content":"pub fn new_array_buffer(size s: Int) -&gt; ArrayBuffer\n\nSynonyms:\nnjs/buffer.new_array_buffer\nnjs/buffer new_array_buffer","url":"njs/buffer.html#new_array_buffer"},{"doc":"njs/buffer","title":"new_typed_array","content":"pub fn new_typed_array(\n  t: TypedArrayType,\n  size s: Int,\n) -&gt; TypedArray\n\nSynonyms:\nnjs/buffer.new_typed_array\nnjs/buffer new_typed_array","url":"njs/buffer.html#new_typed_array"},{"doc":"njs/buffer","title":"set_byte","content":"pub fn set_byte(\n  buffer bf: Buffer,\n  offset o: Int,\n  byte b: BitArray,\n) -&gt; Buffer\n\nSynonyms:\nnjs/buffer.set_byte\nnjs/buffer set_byte","url":"njs/buffer.html#set_byte"},{"doc":"njs/buffer","title":"slice","content":"pub fn slice(buffer bf: Buffer, from f: Int, to t: Int) -&gt; Buffer\n\nSynonyms:\nnjs/buffer.slice\nnjs/buffer slice","url":"njs/buffer.html#slice"},{"doc":"njs/buffer","title":"to_string","content":"pub fn to_string(\n  buffer bf: Buffer,\n  encoding e: Encoding,\n  from f: Int,\n  to t: Int,\n) -&gt; String\n\nSynonyms:\nnjs/buffer.to_string\nnjs/buffer to_string","url":"njs/buffer.html#to_string"},{"doc":"njs/buffer","title":"write","content":"pub fn write(\n  buffer bf: Buffer,\n  bitarray ba: BitArray,\n  encoding e: Encoding,\n  offset o: Int,\n  length l: Int,\n) -&gt; Buffer\n write at offset of buffer for length number of bytes\nSynonyms:\nnjs/buffer.write\nnjs/buffer write","url":"njs/buffer.html#write"},{"doc":"njs/buffer","title":"njs/buffer","content":" Buffer is a view of ArrayBuffer\n","url":"njs/buffer.html"},{"doc":"njs/http","title":"HTTPHandler","content":"pub type HTTPHandler =\n  fn(HTTPRequest) -&gt; Nil\n\n\nSynonyms:\nnjs/http.HTTPHandler\nnjs/http HTTPHandler","url":"njs/http.html#HTTPHandler"},{"doc":"njs/http","title":"HTTPRequest","content":"pub type HTTPRequest\n\n\nSynonyms:\nnjs/http.HTTPRequest\nnjs/http HTTPRequest","url":"njs/http.html#HTTPRequest"},{"doc":"njs/http","title":"HTTPResponse","content":"pub type HTTPResponse =\n  HTTPRequest\n\n\nSynonyms:\nnjs/http.HTTPResponse\nnjs/http HTTPResponse","url":"njs/http.html#HTTPResponse"},{"doc":"njs/http","title":"args","content":"pub fn args(request r: HTTPRequest) -&gt; Json\n\nSynonyms:\nnjs/http.args\nnjs/http args","url":"njs/http.html#args"},{"doc":"njs/http","title":"done","content":"pub fn done(request r: HTTPRequest) -&gt; Nil\n\nSynonyms:\nnjs/http.done\nnjs/http done","url":"njs/http.html#done"},{"doc":"njs/http","title":"error","content":"pub fn error(\n  request r: HTTPRequest,\n  message m: String,\n) -&gt; HTTPRequest\n\nSynonyms:\nnjs/http.error\nnjs/http error","url":"njs/http.html#error"},{"doc":"njs/http","title":"finish","content":"pub fn finish(request r: HTTPRequest) -&gt; Nil\n\nSynonyms:\nnjs/http.finish\nnjs/http finish","url":"njs/http.html#finish"},{"doc":"njs/http","title":"get_headers_out","content":"pub fn get_headers_out(request r: HTTPRequest) -&gt; Json\n\nSynonyms:\nnjs/http.get_headers_out\nnjs/http get_headers_out","url":"njs/http.html#get_headers_out"},{"doc":"njs/http","title":"get_raw_headers_out","content":"pub fn get_raw_headers_out(\n  request r: HTTPRequest,\n) -&gt; Array(#(String, String))\n\nSynonyms:\nnjs/http.get_raw_headers_out\nnjs/http get_raw_headers_out","url":"njs/http.html#get_raw_headers_out"},{"doc":"njs/http","title":"get_raw_variables","content":"pub fn get_raw_variables(request r: HTTPRequest) -&gt; Buffer\n\nSynonyms:\nnjs/http.get_raw_variables\nnjs/http get_raw_variables","url":"njs/http.html#get_raw_variables"},{"doc":"njs/http","title":"get_variables","content":"pub fn get_variables(request r: HTTPRequest) -&gt; Json\n\nSynonyms:\nnjs/http.get_variables\nnjs/http get_variables","url":"njs/http.html#get_variables"},{"doc":"njs/http","title":"headers_in","content":"pub fn headers_in(request r: HTTPRequest) -&gt; Json\n\nSynonyms:\nnjs/http.headers_in\nnjs/http headers_in","url":"njs/http.html#headers_in"},{"doc":"njs/http","title":"internal_redirect","content":"pub fn internal_redirect(\n  request r: HTTPRequest,\n  uri u: String,\n) -&gt; Nil\n\nSynonyms:\nnjs/http.internal_redirect\nnjs/http internal_redirect","url":"njs/http.html#internal_redirect"},{"doc":"njs/http","title":"is_internal","content":"pub fn is_internal(request r: HTTPRequest) -&gt; Bool\n\nSynonyms:\nnjs/http.is_internal\nnjs/http is_internal","url":"njs/http.html#is_internal"},{"doc":"njs/http","title":"log","content":"pub fn log(\n  request r: HTTPRequest,\n  message m: String,\n) -&gt; HTTPRequest\n\nSynonyms:\nnjs/http.log\nnjs/http log","url":"njs/http.html#log"},{"doc":"njs/http","title":"method","content":"pub fn method(request r: HTTPRequest) -&gt; String\n\nSynonyms:\nnjs/http.method\nnjs/http method","url":"njs/http.html#method"},{"doc":"njs/http","title":"parent","content":"pub fn parent(request r: HTTPRequest) -&gt; HTTPRequest\n\nSynonyms:\nnjs/http.parent\nnjs/http parent","url":"njs/http.html#parent"},{"doc":"njs/http","title":"raw_headers_in","content":"pub fn raw_headers_in(\n  request r: HTTPRequest,\n) -&gt; Array(#(String, String))\n\nSynonyms:\nnjs/http.raw_headers_in\nnjs/http raw_headers_in","url":"njs/http.html#raw_headers_in"},{"doc":"njs/http","title":"remote_address","content":"pub fn remote_address(request r: HTTPRequest) -&gt; String\n\nSynonyms:\nnjs/http.remote_address\nnjs/http remote_address","url":"njs/http.html#remote_address"},{"doc":"njs/http","title":"request_buffer","content":"pub fn request_buffer(request r: HTTPRequest) -&gt; Buffer\n\nSynonyms:\nnjs/http.request_buffer\nnjs/http request_buffer","url":"njs/http.html#request_buffer"},{"doc":"njs/http","title":"request_text","content":"pub fn request_text(request r: HTTPRequest) -&gt; String\n\nSynonyms:\nnjs/http.request_text\nnjs/http request_text","url":"njs/http.html#request_text"},{"doc":"njs/http","title":"response_buffer","content":"pub fn response_buffer(request r: HTTPRequest) -&gt; Buffer\n\nSynonyms:\nnjs/http.response_buffer\nnjs/http response_buffer","url":"njs/http.html#response_buffer"},{"doc":"njs/http","title":"response_text","content":"pub fn response_text(request r: HTTPRequest) -&gt; String\n\nSynonyms:\nnjs/http.response_text\nnjs/http response_text","url":"njs/http.html#response_text"},{"doc":"njs/http","title":"return_buffer","content":"pub fn return_buffer(\n  request r: HTTPRequest,\n  code c: Int,\n  return b: Buffer,\n) -&gt; Nil\n\nSynonyms:\nnjs/http.return_buffer\nnjs/http return_buffer","url":"njs/http.html#return_buffer"},{"doc":"njs/http","title":"return_code","content":"pub fn return_code(request r: HTTPRequest, code c: Int) -&gt; Nil\n\nSynonyms:\nnjs/http.return_code\nnjs/http return_code","url":"njs/http.html#return_code"},{"doc":"njs/http","title":"return_text","content":"pub fn return_text(\n  request r: HTTPRequest,\n  code c: Int,\n  return t: String,\n) -&gt; Nil\n\nSynonyms:\nnjs/http.return_text\nnjs/http return_text","url":"njs/http.html#return_text"},{"doc":"njs/http","title":"send_buffer","content":"pub fn send_buffer(\n  request r: HTTPRequest,\n  buffer d: Buffer,\n  options o: a,\n) -&gt; HTTPRequest\n\nSynonyms:\nnjs/http.send_buffer\nnjs/http send_buffer","url":"njs/http.html#send_buffer"},{"doc":"njs/http","title":"send_header","content":"pub fn send_header(request r: HTTPRequest) -&gt; HTTPRequest\n\nSynonyms:\nnjs/http.send_header\nnjs/http send_header","url":"njs/http.html#send_header"},{"doc":"njs/http","title":"send_text","content":"pub fn send_text(\n  request r: HTTPRequest,\n  data d: String,\n) -&gt; HTTPRequest\n\nSynonyms:\nnjs/http.send_text\nnjs/http send_text","url":"njs/http.html#send_text"},{"doc":"njs/http","title":"set_headers_out","content":"pub fn set_headers_out(\n  request r: HTTPRequest,\n  key k: a,\n  value v: b,\n) -&gt; HTTPRequest\n\nSynonyms:\nnjs/http.set_headers_out\nnjs/http set_headers_out","url":"njs/http.html#set_headers_out"},{"doc":"njs/http","title":"set_status","content":"pub fn set_status(\n  request r: HTTPRequest,\n  status s: Int,\n) -&gt; HTTPRequest\n\nSynonyms:\nnjs/http.set_status\nnjs/http set_status","url":"njs/http.html#set_status"},{"doc":"njs/http","title":"set_variables","content":"pub fn set_variables(\n  request r: HTTPRequest,\n  key k: a,\n  value v: b,\n) -&gt; HTTPRequest\n\nSynonyms:\nnjs/http.set_variables\nnjs/http set_variables","url":"njs/http.html#set_variables"},{"doc":"njs/http","title":"status","content":"pub fn status(request r: HTTPRequest) -&gt; Int\n\nSynonyms:\nnjs/http.status\nnjs/http status","url":"njs/http.html#status"},{"doc":"njs/http","title":"subrequest","content":"pub fn subrequest(\n  request r: HTTPRequest,\n  uri u: String,\n  options o: a,\n) -&gt; Promise(HTTPRequest)\n\nSynonyms:\nnjs/http.subrequest\nnjs/http subrequest","url":"njs/http.html#subrequest"},{"doc":"njs/http","title":"uri","content":"pub fn uri(request r: HTTPRequest) -&gt; String\n\nSynonyms:\nnjs/http.uri\nnjs/http uri","url":"njs/http.html#uri"},{"doc":"njs/http","title":"version","content":"pub fn version(request r: HTTPRequest) -&gt; String\n\nSynonyms:\nnjs/http.version\nnjs/http version","url":"njs/http.html#version"},{"doc":"njs/http","title":"warn","content":"pub fn warn(\n  request r: HTTPRequest,\n  message m: String,\n) -&gt; HTTPRequest\n\nSynonyms:\nnjs/http.warn\nnjs/http warn","url":"njs/http.html#warn"},{"doc":"njs/http","title":"njs/http","content":"","url":"njs/http.html"},{"doc":"njs/headers","title":"Headers","content":"pub type Headers\n\n\nSynonyms:\nnjs/headers.Headers\nnjs/headers Headers","url":"njs/headers.html#Headers"},{"doc":"njs/headers","title":"from_array","content":"pub fn from_array(h: Array(#(String, String))) -&gt; Headers\n\nSynonyms:\nnjs/headers.from_array\nnjs/headers from_array","url":"njs/headers.html#from_array"},{"doc":"njs/headers","title":"from_headers","content":"pub fn from_headers(h: Headers) -&gt; Headers\n\nSynonyms:\nnjs/headers.from_headers\nnjs/headers from_headers","url":"njs/headers.html#from_headers"},{"doc":"njs/headers","title":"from_string","content":"pub fn from_string(h: String) -&gt; Headers\n\nSynonyms:\nnjs/headers.from_string\nnjs/headers from_string","url":"njs/headers.html#from_string"},{"doc":"njs/headers","title":"njs/headers","content":"","url":"njs/headers.html"},{"doc":"njs/request","title":"Request","content":"pub type Request\n\n\nSynonyms:\nnjs/request.Request\nnjs/request Request","url":"njs/request.html#Request"},{"doc":"njs/request","title":"RequestOption","content":"pub type RequestOption(h) {\n  RequestOption(body: BitArray, headers: h, method: String)\n  EmptyRequestOption(headers: h, method: String)\n}\n\nRequestOption(body: BitArray, headers: h, method: String)\n\n\nEmptyRequestOption(headers: h, method: String)\n\n\nSynonyms:\nnjs/request.RequestOption\nnjs/request RequestOption","url":"njs/request.html#RequestOption"},{"doc":"njs/request","title":"array_buffer","content":"pub fn array_buffer(request r: Request) -&gt; Promise(ArrayBuffer)\n\nSynonyms:\nnjs/request.array_buffer\nnjs/request array_buffer","url":"njs/request.html#array_buffer"},{"doc":"njs/request","title":"from_request","content":"pub fn from_request(request r: Request, option o: a) -&gt; Request\n\nSynonyms:\nnjs/request.from_request\nnjs/request from_request","url":"njs/request.html#from_request"},{"doc":"njs/request","title":"from_url","content":"pub fn from_url(url u: String, option o: a) -&gt; Request\n\nSynonyms:\nnjs/request.from_url\nnjs/request from_url","url":"njs/request.html#from_url"},{"doc":"njs/request","title":"has_body","content":"pub fn has_body(request r: Request) -&gt; Bool\n\nSynonyms:\nnjs/request.has_body\nnjs/request has_body","url":"njs/request.html#has_body"},{"doc":"njs/request","title":"headers","content":"pub fn headers(request r: Request) -&gt; Headers\n\nSynonyms:\nnjs/request.headers\nnjs/request headers","url":"njs/request.html#headers"},{"doc":"njs/request","title":"json","content":"pub fn json(request r: Request) -&gt; Promise(Json)\n\nSynonyms:\nnjs/request.json\nnjs/request json","url":"njs/request.html#json"},{"doc":"njs/request","title":"method","content":"pub fn method(request r: Request) -&gt; String\n\nSynonyms:\nnjs/request.method\nnjs/request method","url":"njs/request.html#method"},{"doc":"njs/request","title":"text","content":"pub fn text(request r: Request) -&gt; Promise(String)\n\nSynonyms:\nnjs/request.text\nnjs/request text","url":"njs/request.html#text"},{"doc":"njs/request","title":"url","content":"pub fn url(request r: Request) -&gt; String\n\nSynonyms:\nnjs/request.url\nnjs/request url","url":"njs/request.html#url"},{"doc":"njs/request","title":"njs/request","content":"","url":"njs/request.html"},{"doc":"njs/response","title":"Response","content":"pub type Response\n\n\nSynonyms:\nnjs/response.Response\nnjs/response Response","url":"njs/response.html#Response"},{"doc":"njs/response","title":"ResponseOption","content":"pub type ResponseOption(h) {\n  ResponseOption(status: Int, headers: h, status_text: String)\n}\n\nResponseOption(status: Int, headers: h, status_text: String)\n\n\nSynonyms:\nnjs/response.ResponseOption\nnjs/response ResponseOption","url":"njs/response.html#ResponseOption"},{"doc":"njs/response","title":"array_buffer","content":"pub fn array_buffer(response r: Response) -&gt; Promise(ArrayBuffer)\n\nSynonyms:\nnjs/response.array_buffer\nnjs/response array_buffer","url":"njs/response.html#array_buffer"},{"doc":"njs/response","title":"empty","content":"pub fn empty(option o: a) -&gt; Response\n\nSynonyms:\nnjs/response.empty\nnjs/response empty","url":"njs/response.html#empty"},{"doc":"njs/response","title":"from_buffer","content":"pub fn from_buffer(body b: Buffer, option o: a) -&gt; Response\n\nSynonyms:\nnjs/response.from_buffer\nnjs/response from_buffer","url":"njs/response.html#from_buffer"},{"doc":"njs/response","title":"from_string","content":"pub fn from_string(body b: String, option o: a) -&gt; Response\n\nSynonyms:\nnjs/response.from_string\nnjs/response from_string","url":"njs/response.html#from_string"},{"doc":"njs/response","title":"has_body","content":"pub fn has_body(response r: Response) -&gt; Bool\n\nSynonyms:\nnjs/response.has_body\nnjs/response has_body","url":"njs/response.html#has_body"},{"doc":"njs/response","title":"headers","content":"pub fn headers(response r: Response) -&gt; Headers\n\nSynonyms:\nnjs/response.headers\nnjs/response headers","url":"njs/response.html#headers"},{"doc":"njs/response","title":"is_ok","content":"pub fn is_ok(response r: Response) -&gt; Bool\n\nSynonyms:\nnjs/response.is_ok\nnjs/response is_ok","url":"njs/response.html#is_ok"},{"doc":"njs/response","title":"is_redirected","content":"pub fn is_redirected(response r: Response) -&gt; Bool\n\nSynonyms:\nnjs/response.is_redirected\nnjs/response is_redirected","url":"njs/response.html#is_redirected"},{"doc":"njs/response","title":"json","content":"pub fn json(response r: Response) -&gt; Promise(Json)\n\nSynonyms:\nnjs/response.json\nnjs/response json","url":"njs/response.html#json"},{"doc":"njs/response","title":"status","content":"pub fn status(response r: Response) -&gt; Int\n\nSynonyms:\nnjs/response.status\nnjs/response status","url":"njs/response.html#status"},{"doc":"njs/response","title":"status_text","content":"pub fn status_text(response r: Response) -&gt; String\n\nSynonyms:\nnjs/response.status_text\nnjs/response status_text","url":"njs/response.html#status_text"},{"doc":"njs/response","title":"text","content":"pub fn text(response r: Response) -&gt; Promise(String)\n\nSynonyms:\nnjs/response.text\nnjs/response text","url":"njs/response.html#text"},{"doc":"njs/response","title":"url","content":"pub fn url(response r: Response) -&gt; String\n\nSynonyms:\nnjs/response.url\nnjs/response url","url":"njs/response.html#url"},{"doc":"njs/response","title":"njs/response","content":"","url":"njs/response.html"},{"doc":"njs/ngx","title":"JsObject","content":"pub type JsObject {\n  JsObject\n}\n\nJsObject\n\n\nSynonyms:\nnjs/ngx.JsObject\nnjs/ngx JsObject","url":"njs/ngx.html#JsObject"},{"doc":"njs/ngx","title":"SharedDict","content":"pub type SharedDict\n\n\nSynonyms:\nnjs/ngx.SharedDict\nnjs/ngx SharedDict","url":"njs/ngx.html#SharedDict"},{"doc":"njs/ngx","title":"append","content":"pub fn append(ar: Array(a), a: a) -&gt; Array(a)\n\nSynonyms:\nnjs/ngx.append\nnjs/ngx append","url":"njs/ngx.html#append"},{"doc":"njs/ngx","title":"atob","content":"pub fn atob(data d: BitArray) -&gt; BitArray\n\nSynonyms:\nnjs/ngx.atob\nnjs/ngx atob","url":"njs/ngx.html#atob"},{"doc":"njs/ngx","title":"btoa","content":"pub fn btoa(data d: BitArray) -&gt; BitArray\n\nSynonyms:\nnjs/ngx.btoa\nnjs/ngx btoa","url":"njs/ngx.html#btoa"},{"doc":"njs/ngx","title":"export","content":"pub fn export(o: JsObject, f: a) -&gt; JsObject\n\nSynonyms:\nnjs/ngx.export\nnjs/ngx export","url":"njs/ngx.html#export"},{"doc":"njs/ngx","title":"fetch_request","content":"pub fn fetch_request(\n  resource r: Request,\n  options o: a,\n) -&gt; Promise(Response)\n\nSynonyms:\nnjs/ngx.fetch_request\nnjs/ngx fetch_request","url":"njs/ngx.html#fetch_request"},{"doc":"njs/ngx","title":"fetch_url","content":"pub fn fetch_url(\n  resource r: String,\n  options o: a,\n) -&gt; Promise(Response)\n\nSynonyms:\nnjs/ngx.fetch_url\nnjs/ngx fetch_url","url":"njs/ngx.html#fetch_url"},{"doc":"njs/ngx","title":"get","content":"pub fn get(o: JsObject, k: a) -&gt; Result(JsObject, Nil)\n\nSynonyms:\nnjs/ngx.get\nnjs/ngx get","url":"njs/ngx.html#get"},{"doc":"njs/ngx","title":"make_array","content":"pub fn make_array(ls: List(a)) -&gt; Array(a)\n\nSynonyms:\nnjs/ngx.make_array\nnjs/ngx make_array","url":"njs/ngx.html#make_array"},{"doc":"njs/ngx","title":"make_query_string","content":"pub fn make_query_string(q: Json) -&gt; String\n\nSynonyms:\nnjs/ngx.make_query_string\nnjs/ngx make_query_string","url":"njs/ngx.html#make_query_string"},{"doc":"njs/ngx","title":"merge","content":"pub fn merge(o: JsObject, k: a, v: b) -&gt; JsObject\n\nSynonyms:\nnjs/ngx.merge\nnjs/ngx merge","url":"njs/ngx.html#merge"},{"doc":"njs/ngx","title":"name","content":"pub fn name(a: a) -&gt; String\n\nSynonyms:\nnjs/ngx.name\nnjs/ngx name","url":"njs/ngx.html#name"},{"doc":"njs/ngx","title":"object","content":"pub fn object() -&gt; JsObject\n\nSynonyms:\nnjs/ngx.object\nnjs/ngx object","url":"njs/ngx.html#object"},{"doc":"njs/ngx","title":"parse_query_string","content":"pub fn parse_query_string(q: String) -&gt; Json\n\nSynonyms:\nnjs/ngx.parse_query_string\nnjs/ngx parse_query_string","url":"njs/ngx.html#parse_query_string"},{"doc":"njs/ngx","title":"pretty","content":"pub fn pretty(a: a) -&gt; String\n\nSynonyms:\nnjs/ngx.pretty\nnjs/ngx pretty","url":"njs/ngx.html#pretty"},{"doc":"njs/ngx","title":"shared_dict_add","content":"pub fn shared_dict_add(\n  key k: BitArray,\n  value v: a,\n  timeout t: Int,\n) -&gt; Result(Bool, Nil)\n\nSynonyms:\nnjs/ngx.shared_dict_add\nnjs/ngx shared_dict_add","url":"njs/ngx.html#shared_dict_add"},{"doc":"njs/ngx","title":"shared_dict_clear","content":"pub fn shared_dict_clear() -&gt; Nil\n\nSynonyms:\nnjs/ngx.shared_dict_clear\nnjs/ngx shared_dict_clear","url":"njs/ngx.html#shared_dict_clear"},{"doc":"njs/ngx","title":"shared_dict_delete","content":"pub fn shared_dict_delete(key k: BitArray) -&gt; Bool\n\nSynonyms:\nnjs/ngx.shared_dict_delete\nnjs/ngx shared_dict_delete","url":"njs/ngx.html#shared_dict_delete"},{"doc":"njs/ngx","title":"shared_dict_get","content":"pub fn shared_dict_get(key k: BitArray) -&gt; Result(BitArray, Nil)\n\nSynonyms:\nnjs/ngx.shared_dict_get\nnjs/ngx shared_dict_get","url":"njs/ngx.html#shared_dict_get"},{"doc":"njs/ngx","title":"shared_dict_has","content":"pub fn shared_dict_has(key k: BitArray) -&gt; Bool\n\nSynonyms:\nnjs/ngx.shared_dict_has\nnjs/ngx shared_dict_has","url":"njs/ngx.html#shared_dict_has"},{"doc":"njs/ngx","title":"shared_dict_items","content":"pub fn shared_dict_items(\n  max m: Int,\n) -&gt; Array(#(BitArray, BitArray))\n\nSynonyms:\nnjs/ngx.shared_dict_items\nnjs/ngx shared_dict_items","url":"njs/ngx.html#shared_dict_items"},{"doc":"njs/ngx","title":"shared_dict_keys","content":"pub fn shared_dict_keys(max m: Int) -&gt; Array(BitArray)\n\nSynonyms:\nnjs/ngx.shared_dict_keys\nnjs/ngx shared_dict_keys","url":"njs/ngx.html#shared_dict_keys"},{"doc":"njs/ngx","title":"shared_dict_name","content":"pub fn shared_dict_name() -&gt; String\n\nSynonyms:\nnjs/ngx.shared_dict_name\nnjs/ngx shared_dict_name","url":"njs/ngx.html#shared_dict_name"},{"doc":"njs/ngx","title":"shared_dict_pop","content":"pub fn shared_dict_pop(key k: BitArray) -&gt; Result(BitArray, Nil)\n\nSynonyms:\nnjs/ngx.shared_dict_pop\nnjs/ngx shared_dict_pop","url":"njs/ngx.html#shared_dict_pop"},{"doc":"njs/ngx","title":"shared_dict_replace","content":"pub fn shared_dict_replace(\n  key k: BitArray,\n  value v: a,\n) -&gt; Result(Bool, Nil)\n\nSynonyms:\nnjs/ngx.shared_dict_replace\nnjs/ngx shared_dict_replace","url":"njs/ngx.html#shared_dict_replace"},{"doc":"njs/ngx","title":"shared_dict_set","content":"pub fn shared_dict_set(\n  key k: BitArray,\n  value v: a,\n  timeout t: Int,\n) -&gt; Nil\n\nSynonyms:\nnjs/ngx.shared_dict_set\nnjs/ngx shared_dict_set","url":"njs/ngx.html#shared_dict_set"},{"doc":"njs/ngx","title":"shared_dict_size","content":"pub fn shared_dict_size() -&gt; Int\n\nSynonyms:\nnjs/ngx.shared_dict_size\nnjs/ngx shared_dict_size","url":"njs/ngx.html#shared_dict_size"},{"doc":"njs/ngx","title":"to_json","content":"pub fn to_json(a: a) -&gt; Json\n\nSynonyms:\nnjs/ngx.to_json\nnjs/ngx to_json","url":"njs/ngx.html#to_json"},{"doc":"njs/ngx","title":"version","content":"pub fn version() -&gt; String\n\nSynonyms:\nnjs/ngx.version\nnjs/ngx version","url":"njs/ngx.html#version"},{"doc":"njs/ngx","title":"njs/ngx","content":"","url":"njs/ngx.html"},{"doc":"app/misc","title":"decode_uri","content":"pub fn decode_uri(r: HTTPRequest) -&gt; String\n\nSynonyms:\napp/misc.decode_uri\napp/misc decode_uri","url":"app/misc.html#decode_uri"},{"doc":"app/misc","title":"hello","content":"pub fn hello(r: HTTPRequest) -&gt; Nil\n\nSynonyms:\napp/misc.hello\napp/misc hello","url":"app/misc.html#hello"},{"doc":"app/misc","title":"join","content":"pub fn join(r: HTTPRequest) -&gt; Promise(Nil)\n\nSynonyms:\napp/misc.join\napp/misc join","url":"app/misc.html#join"},{"doc":"app/misc","title":"version","content":"pub fn version(r: HTTPRequest) -&gt; Nil\n\nSynonyms:\napp/misc.version\napp/misc version","url":"app/misc.html#version"},{"doc":"app/misc","title":"app/misc","content":" the module implements a few njs exmpales found at\n https://github.com/nginx/njs-examples\n","url":"app/misc.html"},{"doc":"app","title":"exports","content":"pub fn exports() -&gt; JsObject\n\nSynonyms:\napp.exports\napp exports","url":"app.html#exports"},{"doc":"app","title":"app","content":"","url":"app.html"},{"doc":"ngs","title":"bundle_build","content":"pub fn bundle_build(\n  entry e: String,\n  outfile o: String,\n) -&gt; Promise(Result(Nil, String))\n\nSynonyms:\nngs.bundle_build\nngs bundle_build","url":"ngs.html#bundle_build"},{"doc":"ngs","title":"bundle_watch","content":"pub fn bundle_watch(\n  entry e: String,\n  outfile o: String,\n) -&gt; Promise(Result(Nil, String))\n\nSynonyms:\nngs.bundle_watch\nngs bundle_watch","url":"ngs.html#bundle_watch"},{"doc":"ngs","title":"copy_build","content":"pub fn copy_build(\n  sql f: String,\n  outfile o: String,\n) -&gt; Promise(Result(Nil, String))\n\nSynonyms:\nngs.copy_build\nngs copy_build","url":"ngs.html#copy_build"},{"doc":"ngs","title":"copy_watch","content":"pub fn copy_watch(\n  sql f: String,\n  outfile o: String,\n) -&gt; Promise(Result(Nil, String))\n\nSynonyms:\nngs.copy_watch\nngs copy_watch","url":"ngs.html#copy_watch"},{"doc":"ngs","title":"main","content":"pub fn main() -&gt; Promise(Result(Nil, Nil))\n\nSynonyms:\nngs.main\nngs main","url":"ngs.html#main"},{"doc":"ngs","title":"ngs","content":"","url":"ngs.html"},{"doc":"njs/crypto","title":"CryptoKey","content":"pub type CryptoKey\n\n\nSynonyms:\nnjs/crypto.CryptoKey\nnjs/crypto CryptoKey","url":"njs/crypto.html#CryptoKey"},{"doc":"njs/crypto","title":"DecryptAlgorithm","content":"pub type DecryptAlgorithm =\n  EncryptAlgorithm\n\n\nSynonyms:\nnjs/crypto.DecryptAlgorithm\nnjs/crypto DecryptAlgorithm","url":"njs/crypto.html#DecryptAlgorithm"},{"doc":"njs/crypto","title":"EncryptAlgorithm","content":"pub type EncryptAlgorithm {\n  RsaOaep(name: String)\n  AesCtr(name: String, counter: ArrayBuffer, length: Int)\n  AesCbc(name: String, iv: ArrayBuffer)\n  AesGcm(\n    name: String,\n    iv: ArrayBuffer,\n    additional_data: ArrayBuffer,\n    tag_length: Int,\n  )\n}\n\nRsaOaep(name: String)\n\n\nAesCtr(name: String, counter: ArrayBuffer, length: Int)\n\n\nAesCbc(name: String, iv: ArrayBuffer)\n\n\nAesGcm(\n  name: String,\n  iv: ArrayBuffer,\n  additional_data: ArrayBuffer,\n  tag_length: Int,\n)\n\n\nSynonyms:\nnjs/crypto.EncryptAlgorithm\nnjs/crypto EncryptAlgorithm","url":"njs/crypto.html#EncryptAlgorithm"},{"doc":"njs/crypto","title":"Hash","content":"pub type Hash\n\n\nSynonyms:\nnjs/crypto.Hash\nnjs/crypto Hash","url":"njs/crypto.html#Hash"},{"doc":"njs/crypto","title":"Hmac","content":"pub type Hmac\n\n\nSynonyms:\nnjs/crypto.Hmac\nnjs/crypto Hmac","url":"njs/crypto.html#Hmac"},{"doc":"njs/crypto","title":"KeyAlgorithm","content":"pub type KeyAlgorithm {\n  RsaOaepKey(name: String, hash: String)\n  HMACKey(name: String, hash: String, length: Int)\n  AesKey(name: String)\n}\n\nRsaOaepKey(name: String, hash: String)\n RSA-OAEP\n\nHMACKey(name: String, hash: String, length: Int)\n HMAC\n\nAesKey(name: String)\n AES-CTR AES-CBC ASE-GCM\n\nSynonyms:\nnjs/crypto.KeyAlgorithm\nnjs/crypto KeyAlgorithm","url":"njs/crypto.html#KeyAlgorithm"},{"doc":"njs/crypto","title":"create_hash","content":"pub fn create_hash(algorithm a: String) -&gt; Hash\n\nSynonyms:\nnjs/crypto.create_hash\nnjs/crypto create_hash","url":"njs/crypto.html#create_hash"},{"doc":"njs/crypto","title":"create_hmac","content":"pub fn create_hmac(algorithm a: String, secret k: String) -&gt; Hmac\n\nSynonyms:\nnjs/crypto.create_hmac\nnjs/crypto create_hmac","url":"njs/crypto.html#create_hmac"},{"doc":"njs/crypto","title":"decrypt","content":"pub fn decrypt(\n  algorithm a: EncryptAlgorithm,\n  key k: CryptoKey,\n  ciphertext d: ArrayBuffer,\n) -&gt; Promise(ArrayBuffer)\n\nSynonyms:\nnjs/crypto.decrypt\nnjs/crypto decrypt","url":"njs/crypto.html#decrypt"},{"doc":"njs/crypto","title":"digest","content":"pub fn digest(\n  algorithm a: String,\n  data d: ArrayBuffer,\n) -&gt; Promise(ArrayBuffer)\n\nSynonyms:\nnjs/crypto.digest\nnjs/crypto digest","url":"njs/crypto.html#digest"},{"doc":"njs/crypto","title":"encrypt","content":"pub fn encrypt(\n  algorithm a: EncryptAlgorithm,\n  key k: CryptoKey,\n  plaintext d: ArrayBuffer,\n) -&gt; Promise(ArrayBuffer)\n\nSynonyms:\nnjs/crypto.encrypt\nnjs/crypto encrypt","url":"njs/crypto.html#encrypt"},{"doc":"njs/crypto","title":"get_random_values","content":"pub fn get_random_values(typedarray a: TypedArray) -&gt; TypedArray\n\nSynonyms:\nnjs/crypto.get_random_values\nnjs/crypto get_random_values","url":"njs/crypto.html#get_random_values"},{"doc":"njs/crypto","title":"hash_digest","content":"pub fn hash_digest(hash h: Hash, encoding e: Encoding) -&gt; String\n\nSynonyms:\nnjs/crypto.hash_digest\nnjs/crypto hash_digest","url":"njs/crypto.html#hash_digest"},{"doc":"njs/crypto","title":"hash_update","content":"pub fn hash_update(hash h: Hash, data d: BitArray) -&gt; Hash\n\nSynonyms:\nnjs/crypto.hash_update\nnjs/crypto hash_update","url":"njs/crypto.html#hash_update"},{"doc":"njs/crypto","title":"hmac_digest","content":"pub fn hmac_digest(hmac h: Hmac, encoding e: Encoding) -&gt; String\n\nSynonyms:\nnjs/crypto.hmac_digest\nnjs/crypto hmac_digest","url":"njs/crypto.html#hmac_digest"},{"doc":"njs/crypto","title":"hmac_update","content":"pub fn hmac_update(hmac h: Hmac, data d: BitArray) -&gt; Hmac\n\nSynonyms:\nnjs/crypto.hmac_update\nnjs/crypto hmac_update","url":"njs/crypto.html#hmac_update"},{"doc":"njs/crypto","title":"import_key","content":"pub fn import_key(\n  format f: String,\n  key k: ArrayBuffer,\n  algorithm a: KeyAlgorithm,\n  extractable e: Bool,\n  usages ku: Array(String),\n) -&gt; Promise(CryptoKey)\n\nSynonyms:\nnjs/crypto.import_key\nnjs/crypto import_key","url":"njs/crypto.html#import_key"},{"doc":"njs/crypto","title":"sign","content":"pub fn sign(\n  algorithm a: a,\n  key k: CryptoKey,\n  data d: ArrayBuffer,\n) -&gt; Promise(ArrayBuffer)\n\nSynonyms:\nnjs/crypto.sign\nnjs/crypto sign","url":"njs/crypto.html#sign"},{"doc":"njs/crypto","title":"verify","content":"pub fn verify(\n  algorithm a: a,\n  key k: CryptoKey,\n  signature s: ArrayBuffer,\n  data d: ArrayBuffer,\n) -&gt; Promise(Bool)\n\nSynonyms:\nnjs/crypto.verify\nnjs/crypto verify","url":"njs/crypto.html#verify"},{"doc":"njs/crypto","title":"njs/crypto","content":"","url":"njs/crypto.html"}]);